/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lezione260410_lista;

/**
 *
 * @author utente
 */
public class List {
    private Elem head;

    public List(){
        head=null;
    }

    public List(Elem e){
        head=e;
        if (e != null){
            e.prev=null;
        }
    }

    public boolean isEmpty(){
       return head==null;
    }
    //inserisce la chiave k nella lista
    public void Insert (int k){
        Elem e = new Elem(k);
        if (!isEmpty()){
            head.prev=e;
        }
        e.next=head;
        head=e;
    }

     public String toString(){
         Elem e=head;
         String s="";
         while (e != null){
             s += e.toString();
             if (e.next != null) { s+="; ";} else { s+=".";}
             e = e.next;
         }
         return s;
     }

     //restituisce la lunghezza della lista corrente
     public int length(){
         int n=0;
         Elem e=head;
         while (e != null){
             n++;
             e=e.next;
         }
         return n;
     }

     //cerca la chiave k nella lista e restituisce il puntatore all'elemento
     // che la contiene, null altrimenti
     public Elem Search (int k){
         Elem e=head;
         while (e != null){
             if (e.getKey()==k) {
                 return e;
             }
             e=e.next;
         }
         return null;
     }

      public Elem Search_Ric (int k){
          return Search_Ric_App (k, head);
      }

      private Elem Search_Ric_App (int k, Elem e){
          if (e==null) {return null;}
          if (k==e.getKey()) {return e;}
          return Search_Ric_App (k, e.next);
      }


}
